#ifndef POLINOM_H_INCLUDED
#define POLINOM_H_INCLUDED

#include <iostream>
#include <vector>

class Polinom
{
    private:
        int fokszam;                    // fokszm
        std::vector<int> egyutthatok;   // egytthatk (dinamikus, a konstruktorban a heapen ltrehozott tmb is hazsnlhat vektor helyett)

    public:
        /*
         * Hozzunk ltre egy Kivetelek tpust, ami a Polinom osztlyon belli kivtelfajtkat tudja lerni.
         * Ez a publikus rszbe kerl, hogy kvlrl is el tudjuk rni (ld. fprogram.).
         */
        enum Kivetelek
        {
            HibasFokszam,   // Azt jelzi, hogy a konstruktorban a megadott fokszm nullnl kisebb.
            HibasKitevo     // Azt jelzi, hogy a beallit metdussal olyan kitevj egytthat rtkt prbltuk belltani, ami nem is ltezik a polinomban.
        };

        Polinom(int fokszam) throw (Kivetelek);                 // Konstruktor a fokszm megadsval.
        void beallit(int kitevo, int ertek) throw (Kivetelek);  // Belltja a megadott kitevj egytthat rtkt.
        Polinom operator+(const Polinom &masik);                // Polinomok sszeadsa
        Polinom operator*(const Polinom &masik);                // Polinomok szorzsa
        // Tovbbi mveletek implementlhatak.

        friend std::istream& operator>>(std::istream& be, Polinom &p);  // Beolvas opertor
        friend std::ostream& operator<<(std::ostream& ki, Polinom &p);  // Kir opertor
};

std::istream& operator>>(std::istream& be, Polinom &p);  // Beolvas opertor
std::ostream& operator<<(std::ostream& ki, Polinom &p);  // Kir opertor

#endif // POLINOM_H_INCLUDED
